<script lang="ts" setup>
import MsnApiV1 from '@/api/msnApi'
import { computed, onMounted, ref, watch } from 'vue'

// Definición de propiedades
interface UserData {
  id: number
  // Otras propiedades que pueda tener el usuario…
}
interface Reporter {
  email: number
  teams: number
  slack: number
}
interface EventItem {
  id: string | number
  name: string
}
interface SubscriptionItem {
  event: string
  eventId: string | number
  haveSubscription: boolean
  email: boolean
  teams: boolean
  slack: boolean
}

const props = defineProps<{ userData: UserData }>()

// Estado reactivo
const eventsList = ref<EventItem[]>([])
const perPage = ref(20)
const pageOptions = ref<number[]>([5, 10, 20, 50, 100])
const currentPage = ref(1)
const totalRows = ref(1)
const subscriber = ref<any>({})
const subscriptionList = ref<SubscriptionItem[]>([])
const reporters = ref<Reporter>({ email: 0, teams: 0, slack: 0 })
const saving = ref(false)
const isRequest = ref(false)
const isError = ref(false)
const requestMessage = ref('')
const notSubscriberTrigger = ref(0)

// Para la tabla de suscripciones convertimos los campos a headers de VDataTable
const headers = computed(() => [
  { title: 'Event', key: 'event' },
  { title: 'Email', key: 'email' },
  { title: 'Teams', key: 'teams' },
  { title: 'Slack', key: 'slack' },
])

// Total de páginas para la paginación (Vuetify VPagination utiliza "length")
const totalPages = computed(() => Math.ceil(totalRows.value / perPage.value))

// Computed properties
const alertToggleVariant = computed(() => {
  return isError.value ? 'danger' : 'success'
})

const alertToggleText = computed(() => {
  return isError.value ? 'Error!' : 'Success!'
})

// Watchers
watch(perPage, () => {
  getEvents()
})
watch(currentPage, () => {
  getEvents()
})
watch(
  () => eventsList.value,
  (newVal) => {
    console.log('Watching for changes in eventsList: ', newVal)
    getSubscriber()
  }
)
watch(
  () => props.userData,
  (newVal) => {
    console.log('Watching for changes in userData: ', newVal)
    getSubscriber()
  },
  { deep: true }
)
watch(notSubscriberTrigger, (newVal) => {
  console.log('Watching for changes in notSubscriberTrigger: ', newVal)
  buildSubscriptionList()
})
watch(subscriber, (newVal) => {
  console.log('Watching for changes in subscriber: ', newVal)
  getReporters()
  buildSubscriptionList()
})

// Funciones de API
const getEvents = async () => {
  console.info('INFO: getEvents')
  const msn = new MsnApiV1()
  isRequest.value = false
  try {
    const responseEvensData = await msn.getAllEvents(perPage.value, currentPage.value)
    totalRows.value = Number(responseEvensData.headers['x-total'])
    console.debug('getEvents totalRows: ', totalRows.value)
    eventsList.value = responseEvensData.data.data
    console.debug('getEvents eventsList:', eventsList.value)
  } catch (error: any) {
    console.debug('ERROR getEvents', error)
    requestMessage.value = `Events: ${error.response?.data?.message || 'Unknown error'}`
    isError.value = true
    isRequest.value = true
  }
}

const getSubscriber = async () => {
  const msnService = new MsnApiV1()
  isRequest.value = false
  try {
    const response = await msnService.getSubscriberByID(props.userData.id)
    subscriber.value = response.data.data
    console.debug('getSubscriber: ', subscriber.value)
  } catch (error: any) {
    console.debug('ERROR getSubscriber', error)
    requestMessage.value = "Can't get subscriber. Possibly you don't have any subscriber yet."
    isError.value = true
    isRequest.value = true
    notSubscriberTrigger.value = Math.random()
  }
}

const getReporters = async () => {
  console.info('INFO: getReporters with subscriber', subscriber.value.id)
  const msnApi = new MsnApiV1()
  isRequest.value = false
  try {
    const responseReporters = await msnApi.getReportersBySubscriberID(subscriber.value.id)
    const newReporters = responseReporters.data.data.reduce((acc: any, reporter: any) => {
      acc[reporter.reporter] = reporter.id
      return acc
    }, {})
    reporters.value = { ...reporters.value, ...newReporters }
    console.log('getReporters: ', reporters.value)
  } catch (error: any) {
    console.debug('ERROR: Failed to get reporters', error)
    requestMessage.value = error.response?.data?.message || 'Unknown error'
    isError.value = true
    isRequest.value = true
  }
}

const getEventsSubscriptions = async (eventId: string | number, subscriberId: string | number) => {
  console.info('INFO: getEventsSubscriptions')
  const msn = new MsnApiV1()
  let result: Record<string, boolean> = {}
  try {
    const response = await msn.getSubscriptionBySubscriber(eventId, subscriberId)
    console.debug('getEventsSubscriptions response: ', response.data.data)
    const event = response.data.data
    // Se asume que event.subscriptions es un objeto en el que la key es el subscriberId
    const subscriptions = event.subscriptions[subscriberId] || []
    result = subscriptions.reduce((acc: any, reporter: any) => {
      acc[reporter.reporter] = true
      return acc
    }, {})
  } catch (error) {
    console.debug('ERROR: getEventsSubscriptions', error)
  }
  return result
}

const buildSubscriptionList = async () => {
  console.info('INFO: buildSubscriptionList')
  subscriptionList.value = [] // Reiniciar la lista
  const promises = eventsList.value.map(async (event) => {
    const subscriptions = await getEventsSubscriptions(event.id, subscriber.value.id)
    console.log('buildSubscriptionList, subscriptions: ', subscriptions)
    subscriptionList.value.push({
      event: event.name,
      eventId: event.id,
      haveSubscription: subscriptions.email || subscriptions.teams || subscriptions.slack || false,
      email: subscriptions.email || false,
      teams: subscriptions.teams || false,
      slack: subscriptions.slack || false,
    })
  })
  await Promise.all(promises)
}

const toggleSubscription = async (row: any, reporterId: number) => {
  const eventId = row.eventId
  const subscriberId = subscriber.value.id
  isRequest.value = false
  saving.value = true
  const msn = new MsnApiV1()
  try {
    console.log('toggleSubscription, row: ', row)
    console.log('toggleSubscription, reporterId: ', reporterId)
    let response = { data: {} }
    if (!row.haveSubscription) {
      response = await msn.createSubscription(eventId, subscriberId, reporterId)
      requestMessage.value = 'Subscription created'
    } else if (row.email || row.teams || row.slack) { 
      // Si el valor es true, se elimina la suscripción
      response = await msn.deleteReporterFromSubscription(eventId, subscriberId, reporterId)
      requestMessage.value = 'Subscription deleted'
    } else {
      response = await msn.addReporterToSubscription(eventId, subscriberId, reporterId)
      requestMessage.value = 'Subscription updated'
    }
    console.log('toggleSubscription response: ', response.data)
    isError.value = false
  } catch (error: any) {
    console.error('error in toggleSubscription', error)
    requestMessage.value = error.response?.data?.message || 'Error updating subscription'
    isError.value = true
  }
  // Reiniciar la lista y reconstruirla
  subscriptionList.value = []
  await buildSubscriptionList()
  saving.value = false
  isRequest.value = true
}

const finished = async () => {
  await getEvents()
}

// Llamada inicial
onMounted(() => {
  console.debug('DEBUG: mounted UserSubscriptionForm')
  getEvents()
})
</script>

<template>
  <VRow>
    <VCol cols="12">
      <VAlert v-if="isRequest" :color="alertToggleVariant" dense>
        <div class="alert-body">
          <feather-icon icon="InfoIcon" class="mr-50" />
          <span><strong>{{ alertToggleText }}</strong> {{ requestMessage }}.</span>
        </div>
      </VAlert>
    </VCol>

    <VCol cols="12">
      <VCard class="border mt-1" flat>
        <VDataTable
          :headers="headers"
          :items="subscriptionList"
          class="mb-0"
          :class="{'disabled-table': saving}"
          fixed-header
        >
          <template #item.event="{ item }">
            {{ item.event }}
          </template>
          <template #item.email="{ item }">
            <VCheckbox
              v-model="item.email"
              :disabled="reporters.email === 0"
              @change="toggleSubscription(item, reporters.email)"
              hide-details
            />
          </template>
          <template #item.teams="{ item }">
            <VCheckbox
              v-model="item.teams"
              :disabled="reporters.teams === 0"
              @change="toggleSubscription(item, reporters.teams)"
              hide-details
            />
          </template>
          <template #item.slack="{ item }">
            <VCheckbox
              v-model="item.slack"
              :disabled="reporters.slack === 0"
              @change="toggleSubscription(item, reporters.slack)"
              hide-details
            />
          </template>
        </VDataTable>
      </VCard>
    </VCol>
  </VRow>
</template>

<style scoped>
.disabled-table {
  opacity: 0.5;
  pointer-events: none;
}
</style>
